VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsCard"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'====================================
'Author:  Aceng Suparman
'email Address: belehem@msn.com
'====================================

Option Base 1
'
Dim m_LeftValue As Byte
Dim m_Orientation As enOrientation
Dim m_PosX As Single
Dim m_PosY As Single
Dim m_RightValue As Byte
Dim WithEvents m_hImage As PictureBox
Attribute m_hImage.VB_VarHelpID = -1
Dim bPressed As Boolean
'
Const m_Def_LeftValue = 0
Const m_Def_Orientation = cdHorizontal
Const m_Def_PosX = 1
Const m_Def_PosY = 1
Const m_Def_RightValue = 0
Const m_Def_Tag = ""
Const Err_HandleImageError = 10001

Event Click(LeftValue As Byte, RightValue As Byte)
Event MouseMove(Button As Integer, Shift As Integer, LeftValue As Byte, RightValue As Byte)
Event MouseUp(Button As Integer, Shift As Integer, LeftValue As Byte, RightValue As Byte)
Event MouseDown(Button As Integer, Shift As Integer, LeftValue As Byte, RightValue As Byte)

Private CardPosition() As CardPos

Public Property Get hImage() As PictureBox
    Set hImage = m_hImage
End Property

Public Property Set hImage(ByVal vNewValue As PictureBox)
    Set m_hImage = vNewValue
End Property

Public Property Get LeftValue() As Byte
    LeftValue = m_LeftValue
End Property

Public Property Let LeftValue(ByVal vNewValue As Byte)
    m_LeftValue = vNewValue
End Property

Public Property Get Orientation() As enOrientation
    Orientation = m_Orientation
End Property

Public Property Let Orientation(ByVal vNewValue As enOrientation)
    m_Orientation = vNewValue
End Property

Public Property Get PosX() As Single
    PosX = m_PosX
End Property

Public Property Let PosX(ByVal vNewValue As Single)
    m_PosX = vNewValue
End Property

Public Property Get PosY() As Single
    PosY = m_PosY
End Property

Public Property Let PosY(ByVal vNewValue As Single)
    m_PosY = vNewValue
End Property

Public Property Get RightValue() As Byte
    RightValue = m_RightValue
End Property

Public Property Let RightValue(ByVal vNewValue As Byte)
    m_RightValue = vNewValue
End Property
Public Function RemoveCard(LeftVal As Byte, RightVal As Byte) As Boolean
On Error GoTo ErrEx
Dim aCardP() As CardPos, i As Byte, j As Byte
    For i = 1 To UBound(CardPosition)
        If LeftVal <> Val(Left(Format(CardPosition(i).Val, "00"), 1)) Or _
           RightVal <> Val(Right(Format(CardPosition(i).Val, "00"), 1)) Then
           j = j + 1
           ReDim Preserve aCardP(j)
           aCardP(j).PosX1 = CardPosition(i).PosX1
           aCardP(j).PosX2 = CardPosition(i).PosX2
           aCardP(j).PosY1 = CardPosition(i).PosY1
           aCardP(j).PosY2 = CardPosition(i).PosY2
           aCardP(j).Val = CardPosition(i).Val
           aCardP(j).nOrientation = CardPosition(i).nOrientation
           aCardP(j).Face = CardPosition(i).Face
        Else
            fDrawBlank CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
        End If
    Next
    Erase CardPosition
    For i = 1 To UBound(aCardP)
        ReDim Preserve CardPosition(i)
        CardPosition(i).PosX1 = aCardP(i).PosX1
        CardPosition(i).PosX2 = aCardP(i).PosX2
        CardPosition(i).PosY1 = aCardP(i).PosY1
        CardPosition(i).PosY2 = aCardP(i).PosY2
        CardPosition(i).Val = aCardP(i).Val
        CardPosition(i).nOrientation = aCardP(i).nOrientation
        CardPosition(i).Face = aCardP(i).Face
        If CardPosition(i).Face = FaceDown Then
            fDrawBack CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
        Else
            fDrawFrame CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
            fDrawLeftValue Val(Left(Format(CardPosition(i).Val, "00"), 1)), CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
            fDrawRightValue Val(Right(Format(CardPosition(i).Val, "00"), 1)), CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
        End If
    Next
    Erase aCardP
    RemoveCard = True
    Exit Function
ErrEx:
    RemoveCard = False
End Function
Public Function FlipCard(LeftVal As Byte, RightVal As Byte) As Boolean
On Error GoTo ErrEx
    For i = 1 To UBound(CardPosition)
        If LeftVal = Val(Left(Format(CardPosition(i).Val, "00"), 1)) And _
           RightVal = Val(Right(Format(CardPosition(i).Val, "00"), 1)) Then
           If CardPosition(i).Face = FaceDown Then
                fDrawFrame CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
                fDrawLeftValue Val(Left(Format(CardPosition(i).Val, "00"), 1)), CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
                fDrawRightValue Val(Right(Format(CardPosition(i).Val, "00"), 1)), CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
                CardPosition(i).Face = FaceUp
           Else
                fDrawBack CardPosition(i).nOrientation, CardPosition(i).PosX1, CardPosition(i).PosY1
                CardPosition(i).Face = FaceDown
           End If
        End If
    Next
    FlipCard = True
ErrEx:
    FlipCard = False
End Function
Public Function ShowBack()
On Error GoTo ErrHandler:
    If hImage Is Nothing Then Err.Raise Err_HandleImageError
    fDrawBack m_Orientation, m_PosX, m_PosY
    fPostToArray FaceDown
    Exit Function
ErrHandler:
    ShowErrMsg Err.Number
End Function

Public Function ShowFace()
On Error GoTo ErrHandler:
    If hImage Is Nothing Then Err.Raise Err_HandleImageError
    fDrawFrame m_Orientation, m_PosX, m_PosY
    fDrawLeftValue m_LeftValue, m_Orientation, m_PosX, m_PosY
    fDrawRightValue m_RightValue, m_Orientation, m_PosX, m_PosY
    fPostToArray FaceUp
    
    Exit Function
ErrHandler:
    ShowErrMsg Err.Number
End Function


Private Sub Class_Initialize()
    m_LeftValue = m_Def_LeftValue
    m_Orientation = m_Def_Orientation
    m_PosX = m_Def_PosX
    m_PosY = m_Def_PosY
    m_RightValue = m_Def_RightValue
End Sub

Private Function ShowErrMsg(ErrNumber As Integer)
    Select Case ErrNumber
    Case Err_HandleImageError
        MsgBox "Err_HandleImageError"
    Case Else
        MsgBox Err.Description
    End Select
End Function
Private Function fDrawBlank(nOrient As enOrientation, Px As Single, Py As Single)
    hImage.DrawWidth = 2
    hImage.ForeColor = vbBlack
    If nOrient = cdHorizontal Then
        hImage.Line (Px, Py)-(Px + 100, Py + 40), hImage.BackColor, BF
    Else
        hImage.Line (Px, Py)-(Px + 40, Py + 100), hImage.BackColor, BF
    End If
End Function

Private Function fDrawFrame(nOrient As enOrientation, Px As Single, Py As Single)
    hImage.DrawWidth = 1
    hImage.ForeColor = vbRed
    If nOrient = cdHorizontal Then
        hImage.Line (Px, Py)-(Px + 100, Py + 40), vbWhite, BF
        hImage.Line (Px, Py)-(Px + 100, Py)
        hImage.Line (Px + 100, Py)-(Px + 100, Py + 40)
        hImage.Line (Px + 100, Py + 40)-(Px, Py + 40)
        hImage.Line (Px, Py + 40)-(Px, Py - 1)
        hImage.Line (Px + 50, Py + 40)-(Px + 50, Py)
        
    Else
        hImage.Line (Px, Py)-(Px + 40, Py + 100), vbWhite, BF
        hImage.Line (Px, Py)-(Px + 40, Py)
        hImage.Line (Px + 40, Py)-(Px + 40, Py + 100)
        hImage.Line (Px + 40, Py + 100)-(Px, Py + 100)
        hImage.Line (Px, Py + 100)-(Px, Py - 1)
        hImage.Line (Px, Py + 50)-(Px + 40, Py + 50)
    End If
End Function
Private Function fDrawLeftValue(Val As Byte, nOrient As enOrientation, Px As Single, Py As Single)
    hImage.DrawWidth = 1
    hImage.ForeColor = vbRed
    hImage.FillColor = vbRed
    hImage.FillStyle = vbSolid
    If nOrient = cdHorizontal Then
        Select Case Val
        Case 1
            hImage.Circle (Px + 25, Py + 20), 8, vbRed
        Case 2
            hImage.Circle (Px + 12.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 10), 5, vbRed
        Case 3
            hImage.Circle (Px + 12.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 25, Py + 20), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 10), 5, vbRed
        Case 4
            hImage.Circle (Px + 12.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 12.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 30), 5, vbRed
        Case 5
            hImage.Circle (Px + 12.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 12.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 25, Py + 20), 5, vbRed
        Case 6
            hImage.Circle (Px + 12.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 12.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 37.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 25, Py + 10), 5, vbRed
            hImage.Circle (Px + 25, Py + 30), 5, vbRed
        End Select
    Else
        Select Case Val
        Case 1
            hImage.Circle (Px + 20, Py + 20), 8, vbRed
        Case 2
            hImage.Circle (Px + 10, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 37.5), 5, vbRed
        Case 3
            hImage.Circle (Px + 10, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 20, Py + 25), 5, vbRed
            hImage.Circle (Px + 30, Py + 37.5), 5, vbRed
        Case 4
            hImage.Circle (Px + 10, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 37.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 37.5), 5, vbRed
        Case 5
            hImage.Circle (Px + 10, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 37.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 37.5), 5, vbRed
            hImage.Circle (Px + 20, Py + 25), 5, vbRed
        Case 6
            hImage.Circle (Px + 10, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 12.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 37.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 37.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 25), 5, vbRed
            hImage.Circle (Px + 30, Py + 25), 5, vbRed
        End Select
    End If
End Function
Private Function fDrawRightValue(Val As Byte, nOrient As enOrientation, Px As Single, Py As Single)
    hImage.DrawWidth = 1
    hImage.ForeColor = vbRed
    hImage.FillColor = vbRed
    hImage.FillStyle = vbSolid
    If nOrient = cdHorizontal Then
        Select Case Val
        Case 1
            hImage.Circle (Px + 75, Py + 20), 8, vbRed
        Case 2
            hImage.Circle (Px + 62.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 10), 5, vbRed
        Case 3
            hImage.Circle (Px + 62.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 75, Py + 20), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 10), 5, vbRed
        Case 4
            hImage.Circle (Px + 62.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 62.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 30), 5, vbRed
        Case 5
            hImage.Circle (Px + 62.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 62.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 75, Py + 20), 5, vbRed
        Case 6
            hImage.Circle (Px + 62.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 62.5, Py + 10), 5, vbRed
            hImage.Circle (Px + 87.5, Py + 30), 5, vbRed
            hImage.Circle (Px + 75, Py + 10), 5, vbRed
            hImage.Circle (Px + 75, Py + 30), 5, vbRed
        End Select
    Else
        Select Case Val
        Case 1
            hImage.Circle (Px + 20, Py + 75), 8, vbRed
        Case 2
            hImage.Circle (Px + 10, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 87.5), 5, vbRed
        Case 3
            hImage.Circle (Px + 10, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 20, Py + 75), 5, vbRed
            hImage.Circle (Px + 30, Py + 87.5), 5, vbRed
        Case 4
            hImage.Circle (Px + 10, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 87.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 87.5), 5, vbRed
        Case 5
            hImage.Circle (Px + 10, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 87.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 87.5), 5, vbRed
            hImage.Circle (Px + 20, Py + 75), 5, vbRed
        Case 6
            hImage.Circle (Px + 10, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 62.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 87.5), 5, vbRed
            hImage.Circle (Px + 30, Py + 87.5), 5, vbRed
            hImage.Circle (Px + 10, Py + 75), 5, vbRed
            hImage.Circle (Px + 30, Py + 75), 5, vbRed
        End Select
    End If

End Function
Private Function fDrawBack(nOrient As enOrientation, Px As Single, Py As Single)
Dim i As Byte
    hImage.DrawWidth = 1
    hImage.ForeColor = vbBlack
    If nOrient = cdHorizontal Then
        hImage.Line (Px, Py)-(Px + 100, Py + 40), vbWhite, BF
        hImage.ForeColor = vbRed
        For i = 0 To 101 Step 5
           hImage.Line (Px + i, Py)-(Px + i, Py + 40)
        Next i
        For i = 0 To 40 Step 5
           hImage.Line (Px, Py + i)-(Px + 100, Py + i)
        Next i
    Else
        hImage.Line (Px, Py)-(Px + 40, Py + 100), vbWhite, BF
        hImage.ForeColor = vbRed
        For i = 0 To 41 Step 5
           hImage.Line (Px + i, Py)-(Px + i, Py + 100)
        Next i
        For i = 0 To 101 Step 5
           hImage.Line (Px, Py + i)-(Px + 40, Py + i)
        Next i
    End If
End Function

Private Sub Class_Terminate()
    Erase CardPosition
End Sub
Private Function fPostToArray(nFace As enFace)
On Error Resume Next
    Dim i As Integer
    
    i = UBound(CardPosition) + 1
    If i = 0 Then i = 1
    ReDim Preserve CardPosition(i)
    CardPosition(i).PosX1 = m_PosX
    CardPosition(i).PosY1 = m_PosY
    If m_Orientation = cdHorizontal Then
        CardPosition(i).PosX2 = m_PosX + 100
        CardPosition(i).PosY2 = m_PosY + 40
    Else
        CardPosition(i).PosX2 = m_PosX + 40
        CardPosition(i).PosY2 = m_PosY + 100
    End If
    CardPosition(i).Val = Val(m_LeftValue & m_RightValue)
    CardPosition(i).nOrientation = m_Orientation
    CardPosition(i).Face = nFace
End Function

Private Sub m_hImage_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim lVal As Byte, rVal As Byte, i As Integer
    i = MouseInArea(X, Y)
    If i >= 0 Then
        bPressed = True
        lVal = Val(Left(Format(i, "00"), 1))
        rVal = Val(Right(Format(i, "00"), 1))
        RaiseEvent MouseDown(Button, Shift, lVal, rVal)
    End If
End Sub

Private Function MouseInArea(Px As Single, Py As Single) As Integer
On Error GoTo ErrEx
Dim i As Integer
    MouseInArea = -1
    For i = 1 To UBound(CardPosition)
        If CardPosition(i).PosX1 <= Px And CardPosition(i).PosX2 >= Px _
        And CardPosition(i).PosY1 <= Py And CardPosition(i).PosY2 >= Py Then
            MouseInArea = CardPosition(i).Val
            Exit For
        End If
    Next
    Exit Function
ErrEx:
    MouseInArea = -1
    Exit Function
End Function

Private Sub m_hImage_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer, lVal As Byte, rVal As Byte
    i = MouseInArea(X, Y)
    If i >= 0 Then
        lVal = Val(Left(Format(i, "00"), 1))
        rVal = Val(Right(Format(i, "00"), 1))
        RaiseEvent MouseMove(Button, Shift, lVal, rVal)
    End If

End Sub

Private Sub m_hImage_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer, l As Byte, r As Byte, T As String, lVal As Byte, rVal As Byte
    i = MouseInArea(X, Y)
    If i >= 0 Then
        lVal = Val(Left(Format(i, "00"), 1))
        rVal = Val(Right(Format(i, "00"), 1))
        RaiseEvent MouseUp(Button, Shift, lVal, rVal)
    End If
    If i >= 0 And bPressed Then
        bPressed = False
        T = Format(i, "00")
        l = Val(Left(T, 1)): r = Val(Right(T, 1))
        RaiseEvent Click(l, r)
    End If
End Sub
Public Sub PosXY(LeftVal As Byte, RightVal As Byte, ByRef X As Single, ByRef Y As Single)
On Error GoTo ErrEx
Dim i As Byte
    For i = 1 To UBound(CardPosition)
        If LeftVal = Val(Left(Format(CardPosition(i).Val, "00"), 1)) And _
           RightVal = Val(Right(Format(CardPosition(i).Val, "00"), 1)) Or _
           RightVal = Val(Left(Format(CardPosition(i).Val, "00"), 1)) And _
           LeftVal = Val(Right(Format(CardPosition(i).Val, "00"), 1)) Then
            X = CardPosition(i).PosX1
            Y = CardPosition(i).PosY1
        End If
    Next
    Exit Sub
ErrEx:
End Sub
Public Sub CardOrientation(LeftVal As Byte, RightVal As Byte, ByRef oOrientation As enOrientation)
On Error GoTo ErrEx
Dim i As Byte
    For i = 1 To UBound(CardPosition)
        If LeftVal = Val(Left(Format(CardPosition(i).Val, "00"), 1)) And _
           RightVal = Val(Right(Format(CardPosition(i).Val, "00"), 1)) Then
            oOrientation = CardPosition(i).nOrientation
        End If
    Next
    Exit Sub
ErrEx:
End Sub


